LISTING 4

#ifndef INCLUDED_AR_UTILITY_ABCPTRINIT_H
#define INCLUDED_AR_UTILITY_ABCPTRINIT_H

// copyright 1998 by anton rommerskirchen
// this code can be used and copied for free without changes
// no warrenty is given by the author
// enhancements to arommerskirchen@csi.com
// $Id: abcptrinit.h,v 1.1 2001/10/03 12:45:19 ar Exp $

#ifndef INCLUDED_AR_UTILITY_ABCPTR_H
#	include <ar/utility/abcptr.h>
#	undef INCLUDED_AR_UTILITY_ABCPTR_H
#	define INCLUDED_AR_UTILITY_ABCPTR_H
#endif

namespace AR {

namespace Utility {

//-----------------------------------------------------------------------------

template < class AB >
class ABCPtrInit 
	: 
	public ABCPtr < AB >
{
	// construct the reference counted pointer at the 
	// interface side of the system
	// use this only within a factory
	
public:

	// ctor

	explicit ABCPtrInit 
		(
		void* i_p
		) throw ()
  		:
		ABCPtr < AB > (i_p)
	{
		// sets the address delivered by the dll factory

      set_state_good ();
	}

	~ABCPtrInit
		(
		) throw ()
	{
		// NO virtual - we dont need it here
	}

private:

	// forbidden
	ABCPtrInit ();

	ABCPtrInit (const ABCPtrInit&);

	ABCPtrInit& operator= (const ABCPtrInit&);

};

} // end Utility

} // end AR

#endif

// end of file
