LISTING 2

#ifndef INCLUDED_AR_UTILITY_ABCPTRMANAGER_H
#define INCLUDED_AR_UTILITY_ABCPTRMANAGER_H

// copyright 1998 by anton rommerskirchen
// this code can be used and copied for free without changes
// no warrenty is given by the author
// enhancements to arommerskirchen@csi.com
// $Id: abcptrmanager.h,v 1.1 2001/10/03 12:45:19 ar Exp $

namespace AR {

namespace Utility {

union Chunk;

//------------------------------------------------------------------------------

// guard against duplicate definitions ..

class ABCPtrManager
{
	// manager class for the interface with memory management
	// and dll reference counting, dynamic linking and releasing

public:

	typedef void (*Pfunc)();

public:

	ABCPtrManager
		(
		)
	{
		// we do not need to instantiate a manager.
		// it is only an interface at this point
	}

	virtual ~ABCPtrManager
		(
		);

	// this has to be defined: deliver properly aligned memory
	// of this size
	virtual Chunk*
	allocate
		(
		int	i_total_size_in_bytes
		) ;

	// this has to be defined: give the memory free
	virtual void
	deallocate
		(
		Chunk*	i_chunks	// address in memory
		) ;

	// this has to be defined: add a connection to the manager
	virtual void
	connect
		(
		) ;

	// this has to be defined: subtract a connection 
	// from the manager -- and free
	virtual void
	disconnect
		(
		) ;

	// this has to be defined: subtract a connection 
	// from the manager -- but NO free
	virtual void
	decrement
		(
		) ;

	// this has to be defined: deliver a factory which can be
	// casted to the needs of the implementation in the prg
	// factory. placeholder is a pointer of a void function...
	virtual Pfunc
	get_factory
		(
		) ;
}; // end ABCPtrManager

// a simple default for all users
extern ABCPtrManager* g_default_manager_p;

} // end Utility

} // end AR


#endif

// end of file


