LISTING 1

#ifndef INCLUDED_AR_UTILITY_CHUNK_H
#define INCLUDED_AR_UTILITY_CHUNK_H

// copyright 1998 by anton rommerskirchen
// this code can be used and copied for free without changes
// no warrenty is given by the author
// enhancements to arommerskirchen@csi.com
// $Id: chunk.h,v 1.1 2001/10/03 12:45:19 ar Exp $

namespace AR {

namespace Utility {

class ABCPtrManager;

union Chunk
{
	// memory tile -- see stroustop 2.nd edition
	// aligning requirements are fullfilled by it

	enum Memory_state
	{
		// state of a tile
		null		= 0,	// dirty trick - uninitialized 
					// static mem is null per default ...
		good		= 1,
		bad			= 2,
		free		= 3,
		deleted		= 4
	};

	struct Info
	{
		// management infos for 1.st tile are here

		// callback object for free is here
		ABCPtrManager*	_manager;

		// length of memory
		int				_length;

		// count of connections for the object
		int				_count;

		// state of object - see Memory_state
		char			_state;
	};

   struct Link
   {
		// callback object is here
		ABCPtrManager*	_manager;

		// length of this node
		int _length;

		// simple linked list of free nodes
		Chunk* _next;
   };

	// data -- can be
	int			_i;		// an int ...
	char		_c;		// or a char ...
	void*		_p;		// or a pointer ...
	long double	_ld;	// or a float

	Link		_l;		// or a node on a free-list

	Info		_s;		// or a real active object
}; // end Chunk

} // end Utility

} // end AR

#endif

// end of file
