// copyright 1998 by anton rommerskirchen
// this code can be used and copied for free without changes
// no warrenty is given by the author
// enhancements to arommerskirchen@csi.com
// $Id: abcptrmanager.cpp,v 1.1 2001/10/03 12:45:19 ar Exp $

//
// implementation of a manager
// use new and delete
// use loadlibrary and freelibrary
//

#ifndef INCLUDED_AR_UTILITY_ABCPTRMANAGER_H
#	include <ar/utility/abcptrmanager.h>
#	undef INCLUDED_AR_UTILITY_ABCPTRMANAGER_H
#	define INCLUDED_AR_UTILITY_ABCPTRMANAGER_H
#endif

#ifndef INCLUDED_AR_UTILITY_CHUNK_H
#	include <ar/utility/chunk.h>
#	undef INCLUDED_AR_UTILITY_CHUNK_H
#	define INCLUDED_AR_UTILITY_CHUNK_H
#endif

#ifndef INCLUDED_STDEXCEPT
#	include <stdexcept>
#	undef INCLUDED_STDEXCEPT
#	define INCLUDED_STDEXCEPT
#endif

#ifndef INCLUDED_STRING
#	include <string>
#	undef INCLUDED_STRING
#	define INCLUDED_STRING
#endif

//----------------------------------------------------------------------------
AR::Utility::ABCPtrManager::~ABCPtrManager
	(
	)
{
	disconnect ();
}

//----------------------------------------------------------------------------

AR::Utility::Chunk*
AR::Utility::ABCPtrManager::allocate
	(
	int i_count
	)
{
	// allocate the memory for the chunks - as char array, properly aligned
	// throw a bad_alloc, if memory is out

	char *p = new char [i_count];


#if defined(_MSC_VER) && !defined(__MWERKS__)
	if (!p)
	{
		// yes, this ist _still_ needed. see ms vc ++ 6.0 help for new ....

		throw std::bad_alloc ("dllfactory -- out of memory");
	}
#endif
	Chunk* cp = (AR::Utility::Chunk*)p;

   cp->_s._length = i_count;

	return cp;
}

//----------------------------------------------------------------------------
void
AR::Utility::ABCPtrManager::deallocate
	(
	AR::Utility::Chunk* i_mem
	)
{
	// free the memory of the chunks - as char array

	delete [] ((char*)i_mem);
}

//----------------------------------------------------------------------------

void
AR::Utility::ABCPtrManager::connect
	(
   )
{
}

//----------------------------------------------------------------------------

void
AR::Utility::ABCPtrManager::disconnect
	(
   )
{
	decrement ();
}

//----------------------------------------------------------------------------

void
AR::Utility::ABCPtrManager::decrement
	(
   )
{
}

//----------------------------------------------------------------------------

AR::Utility::ABCPtrManager::Pfunc
AR::Utility::ABCPtrManager::get_factory
	(
   )
{
	return (Pfunc)0;
}

//----------------------------------------------------------------------------

namespace AR {

namespace Utility {

static ABCPtrManager g_default_manager;

ABCPtrManager* g_default_manager_p = &g_default_manager;

}

}

// end of file


