#ifndef INCLUDED_MYMANAGER_H
#define INCLUDED_MYMANAGER_H

#ifndef INCLUDED_AR_UTILITY_ABCPTR_H
#	include <ar/utility/abcptrmanager.h>
#	undef INCLUDED_AR_UTILITY_ABCPTR_H
#	define INCLUDED_AR_UTILITY_ABCPTR_H
#endif

// exception classes are here
#ifndef INCLUDED_STDEXCEPT
#	include <stdexcept>
#	undef INCLUDED_STDEXCEPT
#	define INCLUDED_STDEXCEPT
#endif

#ifndef INCLUDED_STRING
#	include <string>
#	undef INCLUDED_STRING
#	define INCLUDED_STRING
#endif

// we need this for the dll loadings ...
#if __windows__
#ifndef INCLUDED_WINDOWS_H
#	include <windows.h>
#	undef INCLUDED_WINDOWS_H
#	define INCLUDED_WINDOWS_H
#endif
#endif

#if __GNUG__
#ifndef INCLUDED_WINDOWS_H
#	include <dlfcn.h>
#	undef INCLUDED_WINDOWS_H
#	define INCLUDED_WINDOWS_H
#endif

typedef void* HINSTANCE;
#endif

class Mymanager 
	:
	public	AR::Utility::ABCPtrManager
{
	int _refs;

	std::string _name_of_dll;

	std::string _name_of_factory;

	HINSTANCE _dll_handle;

	Pfunc _factory;

public:

	Mymanager
		(
		const std::string& i_name_of_dll,
		const std::string& i_name_of_factory
		)
		:
		_name_of_dll (i_name_of_dll),
		_name_of_factory (i_name_of_factory),
		_dll_handle (0),
		_factory (0),
		_refs (0)
	{
	}

	/* virtual */ ~Mymanager
		(
		) ;

	// this has to be defined: add a connection to the manager
	/* virtual */ void
	connect
		(
		) throw (std::overflow_error) ;

	// this has to be defined: subtract a connection from the manager
	/* virtual */ void
	disconnect
		(
		) throw () ;

	// this has to be defined: subtract a connection 
	// from the manager -- but NO free
	/* virtual */ void
	decrement
		(
		) throw () ;

	/* virtual */ Pfunc
	get_factory
		(
		);

	int
	get_refs
		(
		) const
	{
		return _refs;
	}
};

#endif

// end of file
