#ifndef INCLUDED_MYMANAGER_H
#define INCLUDED_MYMANAGER_H

/* Copyright (C) 2001 ATRSoft GmbH 
   This file is part of the ATRSoft GmbH utilitys.

   The ATRSoft GmbH utilitys is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or any later version.

   The ATRSoft GmbH utilitys is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the ATRSoft GmbH utilitys; see the file LICENSE.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

// http://www.atrsoft.de
// mailto: info@atrsoft.de

#ifndef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#	include <atrsoft/utility/include/atrp.h>
#	undef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#	define INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#endif

#ifndef INCLUDED_STRING
#	include <string>
#	undef INCLUDED_STRING
#	define INCLUDED_STRING
#endif

#ifndef INCLUDED_NEW
#	include <new>
#	undef INCLUDED_NEW
#	define INCLUDED_NEW
#endif

#define ATRP_ON_LINUX 1
#define ATRP_ON_WINDOWS 0

// historisch: ein HINSTANCE ist unter Windows die 
// referenz auf eine dynamisch geladene prozedur


#if ATRP_ON_LINUX
typedef void* HINSTANCE;
#endif

#if ATRP_ON_WINDOWS
// we need this for the dll loadings ...
#ifndef INCLUDED_WINDOWS_H
#	include <windows.h>
#	undef INCLUDED_WINDOWS_H
#	define INCLUDED_WINDOWS_H
#endif
#endif


class Mymanager 
    :
    public ATRSoft::Utility::AtrpManager
{
    int refs_;

    std::string name_of_so_;

    std::string name_of_factory_;

    HINSTANCE handle_;

    Pfunc factory_;

public:

    Mymanager
        (
	const std::string& i_name_of_so,
	const std::string& i_name_of_factory
	) throw (std::bad_alloc)
	:
	refs_ (0),
	name_of_so_ (i_name_of_so),
	name_of_factory_ (i_name_of_factory),
	handle_ (0),
	factory_ (0)
    {
    }

    /* virtual */ ~Mymanager
        (
	) throw ();

    // this has to be defined: add a connection to the manager
    /* virtual */ void
    connect
        (
	) throw ();

    // this has to be defined: subtract a connection from the manager
    /* virtual */ void
    disconnect
        (
	) throw () ;

    // this has to be defined: subtract a connection 
    // from the manager -- but NO free
    /* virtual */ void
    decrement
        (
	) throw () ;

    /* virtual */ Pfunc
    get_factory
        (
	) throw (std::runtime_error);

    int
    get_refs
        (
	) const throw ()
    {
	return refs_;
    }
};

#endif

// end of file
