#ifndef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRPINIT_H
#define INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRPINIT_H

// $Id: atrpinit.h,v 1.3 2001/10/04 12:27:36 ar Exp $
/* Copyright (C) 2001 ATRSoft GmbH 
   This file is part of the ATRSoft GmbH utilitys.

   The ATRSoft GmbH utilitys is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or any later version.

   The ATRSoft GmbH utilitys is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the ATRSoft GmbH utilitys; see the file LICENSE.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

// http://www.atrsoft.de
// mailto: info@atrsoft.de


#ifndef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#	include <atrsoft/utility/include/atrp.h>
#	undef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#	define INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRP_H
#endif

namespace ATRSoft {

namespace Utility {

//-----------------------------------------------------------------------------

template < typename AB >
class AtrpInit 
    : 
    public Atrp <AB>
{
    // construct the reference counted pointer at the 
    // interface side of the system
    // use this only within a factory
    
    // nur fuer die programmfactory gedacht ....
	
public:

    // ctor

    explicit AtrpInit 
        (
	void* i_p
	) throw ()
	:
	Atrp <AB> (i_p)
    {
	// sets the address delivered by the dll factory

	set_state_good ();
    }

    ~AtrpInit
        (
	) throw ()
    {
	// NO virtual - we dont need it here
    }

private:

    // forbidden
    AtrpInit ();

    AtrpInit (const AtrpInit&);

    AtrpInit& operator= (const AtrpInit&);

}; 

} // end Utility

} // end Atrsoft

#endif

// end of file
