// $Id: atrpimplfact.cpp,v 1.5 2001/10/10 06:34:27 ar Exp $

/* Copyright (C) 2001 ATRSoft GmbH 
   This file is part of the ATRSoft GmbH utilitys.

   The ATRSoft GmbH utilitys is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or any later version.

   The ATRSoft GmbH utilitys is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the ATRSoft GmbH utilitys; see the file LICENSE.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

// http://www.atrsoft.de
// mailto: info@atrsoft.de

// visual c++ mfc add on. we dont need this if no afx app....
// for mfc apps you have to remove the double slashs 
// #include <stdafx.h>

// 
// create an instance of Y
// deliver the address of its counted reference ptr
//
// the atrp instantiation is here
#ifndef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRPIMPL_H
#	include <atrsoft/utility/include/atrpimpl.h>
#	undef INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRPIMPL_H
#	define INCLUDED_ATRSOFT_UTILITY_INCLUDE_ATRPIMPL_H
#endif

// placement new
#ifndef INCLUDED_NEW
#	include <new>
#	undef INCLUDED_NEW
#	define INCLUDED_NEW
#endif

// the interface class
// here you have to include YOUR interface class definition
#ifndef INCLUDED_X_H
#	include "x.h"
#	undef INCLUDED_X_H
#	define INCLUDED_X_H
#endif

// the implementation class - the only place where we need it
// here you have to include YOUR implementation class definition
#ifndef INCLUDED_Y_H
#	include "y.h"
#	undef INCLUDED_Y_H
#	define INCLUDED_Y_H
#endif

#define ATRP_ON_LINUX 1


#if ATRP_ON_LINUX
#define __declspec(dllexport) /* nothing */
#endif

//----------------------------------------------------------------------------

// well. if you dont want c code here, use the full mangled name instead.
// in this case, its
// ?makeAX_InDll@@YAPAXHPAVABCPtrManager@Utility@AR@@@Z
// note:
// although the name is _makeAX_InDll, use not the _ in the program...
// ... if it is ms vc. for borland use it, for watcom its at the back ...
// happy hunting (hinthint: use map file ...)
// for borland 5.02 it is
// @makeAX_InDll$qip24AR@Utility@ABCPtrManager
//

// MINI HOWTO:
// Step zero
// you need a set of a class X and Y . Y is derived and you want to deliver a
// atrp for an instance of Y
//
// Step one
// you copy this file an change the include statements to fit X and Y
//
// Step two
// you change y inside this code where needed against Y
// Hint: Atrpimplinit, placemant new
// 
// Step three
// you change the argument for counter against all needed args for your 
// used ctor of your Y 
//
// Step four
// you change the name of makeAX_InImpl to something like name mangeleg or registert
// so that there is no chance to have a conflict
//
// Step five
// you proceed equal with the prg factory 
//
// Step six
// you compile your factory code an link
// Hint: libtool
// Hint: g++ -fpic -c -o XXX.o XXX.cpp
//       g++ -shared -o XXX.so XXX.o .....
//       g++ -I. -rdynamic -g -c withdlls.cpp
//       g++ -I. -rdynamic -o withdlls withdlls.o mymanager.o abcptrmanager.o abcptrprgfact.o -ldl


extern "C" {

__declspec ( dllexport )
void*
makeAX_InImpl
   (
   int i_counter,
   ATRSoft::Utility::AtrpManager* i_manager
   )
{
    // create an object and deliver a reference pointer
    // use the allocation and deallocation functions of manager
    // it is possible to use a delivered manager for this
    // if you use one inside the dll, be carefull at
    // disconnection of the dll
  
    // the allocation function has to obey the aligning rules
    // deliver the address as a void* because of the c interface...
  
    // well. here it is. allocate memory and initialize
    // the first reference pointer

    ATRSoft::Utility::AtrpImplInit p (
				    ((sizeof(Y) + sizeof(ATRSoft::Utility::Chunk) - 1)
				     / sizeof (ATRSoft::Utility::Chunk) + 1)
				    * sizeof(ATRSoft::Utility::Chunk),
				    i_manager);
  
    void* addr;

    try
    {
	// use any ctor you want to use today
	// if you need different ones, use different factorys
      
	addr = new (p.get_adr ()) Y (i_counter);

	return addr;
    }
  
    catch (...)
    {
	// no memory leaks ...
	p.free_memory ();
      
	throw;
    }
}

} // extern "C"

// end of file
